/*
** Author: Dimitris Diochnos
** e-mail: diochnos@gmail.com
**
** File Name: ansa.cpp
**
** Date Started : 20 April 2006.
** Date Finished: 28 April 2006.
**
** Tab space: 3
**
**
** Definitions for mighty heroes.
**
*/

#include <iostream>
#include <cstring>
#include <ctime>
#include "mighty_classes.h"

/*
** External global variables.
*/
extern char * Alchemists_Names [];
extern char * Barbarians_Names [];
extern char * Beastmasters_Names [];
extern char * Death_Knights_Names [];
extern char * Demoniacs_Names [];
extern char * Knights_Names [];
extern char * Overlords_Names [];
extern char * Planeswalkers_Names [];
extern char * Rangers_Names [];

int 	main (int argc, char * argv [])
{
	double * 		probabilities;
	clock_t 			start, finish;
	unsigned char 	pointer;


	if (argc != 3) {
		std::cout << "Usage: Program expects 2 arguments." << std::endl;
		std::cout << "1st  : Hero Class." << std::endl;
		std::cout << "2nd  : Hero Name." << std::endl << std::endl;
		std::cout << "Valid names for Hero Classes:" << std::endl;
		std::cout << "Alchemist, Barbarian, Beastmaster, Death_Knight, " << std::endl;
		std::cout << "Demoniac, Knight, Overlord, Planeswalker, Ranger." << std::endl << std::endl;
		std::cout << "Valid names for Heroes:" << std::endl;
		for (pointer = 0; pointer < NUM_HEROES; pointer++) {
			std::cout << Alchemists_Names [pointer] << " ";
			if (pointer == 3)
				std::cout << std::endl;
		}
		std::cout << std::endl << std::endl;
		for (pointer = 0; pointer < NUM_HEROES; pointer++) {
			std::cout << Barbarians_Names [pointer] << " ";
			if (pointer == 3)
				std::cout << std::endl;
		}
		std::cout << std::endl << std::endl;
		for (pointer = 0; pointer < NUM_HEROES; pointer++) {
			std::cout << Beastmasters_Names [pointer] << " ";
			if (pointer == 3)
				std::cout << std::endl;
		}
		std::cout << std::endl << std::endl;
		for (pointer = 0; pointer < NUM_HEROES; pointer++) {
			std::cout << Death_Knights_Names [pointer] << " ";
			if (pointer == 3)
				std::cout << std::endl;
		}
		std::cout << std::endl << std::endl;
		for (pointer = 0; pointer < NUM_HEROES; pointer++) {
			std::cout << Demoniacs_Names [pointer] << " ";
			if (pointer == 3)
				std::cout << std::endl;
		}
		std::cout << std::endl << std::endl;
		for (pointer = 0; pointer < NUM_HEROES + 1; pointer++) { 	// There is also Sir Mullich.
			std::cout << Knights_Names [pointer] << " ";
			if (pointer == 4)
				std::cout << std::endl;
		}
		std::cout << std::endl << std::endl;
		for (pointer = 0; pointer < NUM_HEROES; pointer++) {
			std::cout << Overlords_Names [pointer] << " ";
			if (pointer == 3)
				std::cout << std::endl;
		}
		std::cout << std::endl << std::endl;
		for (pointer = 0; pointer < NUM_HEROES; pointer++) {
			std::cout << Planeswalkers_Names [pointer] << " ";
			if (pointer == 3)
				std::cout << std::endl;
		}
		std::cout << std::endl << std::endl;
		for (pointer = 0; pointer < NUM_HEROES + 1; pointer++) { 	// There is also Gelu.
			std::cout << Rangers_Names [pointer] << " ";
			if (pointer == 4)
				std::cout << std::endl;
		}
		std::cout << std::endl;

		exit (1);
	}


	/*
	** Program has 3 arguments. Prepare for execution.
	*/


	char * 	given_class = new char [strlen (argv [1]) + 1];
	char * 	given_name = new char [strlen (argv [2]) + 1];

	// Convert to UPPERCASE.
	strcpy (given_class, argv [1]);
	for (pointer = 0; pointer < strlen (argv [1]); pointer++)
		given_class [pointer] = toupper ( given_class [pointer] );

	// Convert to UPPERCASE.
	strcpy (given_name, argv [2]);
	for (pointer = 0; pointer < strlen (argv [2]); pointer++)
		given_name [pointer] = toupper ( given_name [pointer] );

	/*
	** Validate user input.
	*/
	unsigned char 	classification;
	unsigned char 	name;

	if (strcmp (given_class, "ALCHEMIST") == 0 )
		classification = ALCHEMIST;
	else if (strcmp (given_class, "BARBARIAN") == 0 )
		classification = BARBARIAN;
	else if (strcmp (given_class, "BEASTMASTER") == 0 )
		classification = BEASTMASTER;
	else if (strcmp (given_class, "DEATH_KNIGHT") == 0 )
		classification = DEATH_KNIGHT;
	else if (strcmp (given_class, "DEMONIAC") == 0 )
		classification = DEMONIAC;
	else if (strcmp (given_class, "KNIGHT") == 0 )
		classification = KNIGHT;
	else if (strcmp (given_class, "OVERLORD") == 0 )
		classification = OVERLORD;
	else if (strcmp (given_class, "PLANESWALKER") == 0 )
		classification = PLANESWALKER;
	else if (strcmp (given_class, "RANGER") == 0 )
		classification = RANGER;
	else {
		delete 	[] given_class;
		delete 	[] given_name;

		std::cerr << "Invalid Hero class given." << std::endl;
		std::cerr << "Please execute program without arguments to view available choices." << std::endl;

		exit (2);
	}

	switch(classification) {
		case ALCHEMIST:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Alchemists_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case BARBARIAN:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Barbarians_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case BEASTMASTER:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Beastmasters_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case DEATH_KNIGHT:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Death_Knights_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case DEMONIAC:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Demoniacs_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case KNIGHT:
			for (pointer = 0; pointer < NUM_HEROES + 1; pointer++) {
				if (strcmp (given_name, Knights_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case OVERLORD:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Overlords_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case PLANESWALKER:
			for (pointer = 0; pointer < NUM_HEROES; pointer++) {
				if (strcmp (given_name, Planeswalkers_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		case RANGER:
			for (pointer = 0; pointer < NUM_HEROES + 1; pointer++) {
				if (strcmp (given_name, Rangers_Names [pointer]) == 0) {
					name = pointer;
					goto 	normal_execution;
				}
			}
			goto 	name_error;
			break;

		default:
name_error:
			std::cout << "Invalid Hero name given." << std::endl;
			std::cerr << "Please execute program without arguments to view available choices." << std::endl;

			delete 	[] given_class;
			delete 	[] given_name;

			exit (4);

			break;
	}


	/*
	** Procceed to execution of ANSA policy.
	*/
normal_execution:

	HERO 	yet_another_hero (classification, name);

	start = clock ();
	probabilities = yet_another_hero.ANSA_policy ();
	finish = clock ();

	/*
	** Print Results for specific hero.
	*/
	yet_another_hero.print_Name ();
	for (pointer = 1; pointer < DIFF_SEC_SKILLS; pointer++)
		std::cout << (char *) get_skill_name_12 (pointer) << ": " << (double) 100.0 * probabilities [pointer] << " %." << std::endl;
	std::cout << std::endl;

	std::cout << "Duration    : " << (double) (finish - start) / CLOCKS_PER_SEC << " seconds." << std::endl;

	delete 	[] probabilities;

	return 	0;
}
