/*
** Author: Dimitris Diochnos
** e-mail: diochnos@gmail.com
**
** File Name: mighty_classes.cpp
**
** Date Started : 20 April 2006.
** Date Finished: 28 April 2006.
**
** Tab space: 3
**
**
** Definitions for the 'Hero' class.
**
*/

#include <iostream>
#include "mighty_classes.h"

/*****************************************************************************/

char * Alchemists_Names []    = { "FAFNER", "IONA", "NEELA", "PIQUEDRAM", "JOSEPHINE", "RISSA", "THANE", "TOROSAR" };
char * Barbarians_Names []    = { "CRAG_HACK", "GRETCHIN", "GURNISSON", "JABARKAS", "KRELLION", "SHIVA", "TYRAXOR", "YOG" };
char * Beastmasters_Names []  = { "ALKIN", "BROGHILD", "BRON", "DRAKON", "GERWULF", "KORBAC", "TAZAR", "WYSTAN" };
char * Death_Knights_Names [] = { "CHARNA", "CLAVIUS", "GALTHRAN", "ISRA", "MOANDOR", "TAMIKA", "STRAKER", "VOKIAL" };
char * Demoniacs_Names []     = { "RASHKA", "CALH", "FIONA", "IGNATIUS", "MARIUS", "NYMUS", "PYRE", "OCTAVIA" };
char * Knights_Names []       = { "EDRIC", "ORRIN", "SYLVIA", "LORD_HAART", "VALESKA", "CHRISTIAN", "SORSHA", "TYRIS", "SIR_MULLICH" };
char * Overlords_Names []     = { "AJIT", "ARLACH", "DACE", "DAMACON", "GUNNAR", "LORELEI", "SHAKTI", "SYNCA" };
char * Planeswalkers_Names [] = { "ERDAMON", "FIUR", "IGNISSA", "KALT", "LACUS", "MONERE", "PASIS", "THUNAR" };
char * Rangers_Names []       = { "CLANCY", "IVOR", "JENOVA", "KYRRE", "MEPHALA", "RYLAND", "THORGRIM", "UFRETIN", "GELU" };

/*****************************************************************************/

unsigned char Magic_Schools []         = { AIR_MAGIC, EARTH_MAGIC, FIRE_MAGIC, WATER_MAGIC };

/*****************************************************************************/

// Magic Schools:                             A                     E     F                                                        W
unsigned char Alchemist_secSkill []    = { 0, 4, 5,  8, 4, 6, 3, 3, 3, 4, 1, 2, 4,  3, 10,  6, 2, 4, 3,  0,  6, 4, 5, 3, 4, 3,  4, 2, 6 };
unsigned char Barbarian_secSkill []    = { 0, 3, 7,  6, 8, 8, 1, 2, 3, 2, 2, 1, 1,  5,  4,  7, 3, 3, 2,  0, 10, 8, 6, 1, 8, 1,  8, 0, 2 };
unsigned char Beastmaster_secSkill []  = { 0, 1, 7, 10, 8, 7, 1, 1, 3, 1, 0, 6, 1,  5,  4,  8, 2, 2, 8,  0,  5, 8, 5, 1, 7, 1,  6, 2, 2 };
unsigned char Death_secSkill []        = { 0, 2, 5,  5, 5, 7, 2, 4, 4, 0, 1, 0, 5,  0,  4,  5, 1, 4, 8, 10,  7, 4, 5, 2, 4, 4,  5, 3, 6 };
unsigned char Demoniac_secSkill []     = { 0, 2, 6,  7, 5, 7, 4, 3, 3, 3, 4, 2, 2,  3,  4, 10, 2, 2, 4,  0,  8, 4, 6, 2, 5, 3,  6, 1, 4 };
unsigned char Knight_secSkill []       = { 0, 3, 5,  5, 5, 8, 4, 2, 2, 6, 1, 2, 1, 10,  4,  5, 3, 2, 8,  0,  7, 4, 5, 1, 4, 1,  7, 4, 3 };
unsigned char Overlord_secSkill []     = { 0, 1, 6,  6, 8, 7, 3, 2, 3, 4, 2, 1, 1,  8,  4,  8, 1, 3, 4,  0,  8, 5, 6, 1, 5, 2, 10, 0, 3 };
unsigned char Planeswalker_secSkill [] = { 0, 2, 8,  5, 8, 8, 2, 2, 3, 3, 3, 1, 1,  3,  8,  8, 2, 3, 5,  0,  9, 6, 2, 1, 6, 1,  8, 2, 2 };
unsigned char Ranger_secSkill []       = { 0, 1, 8,  8, 6, 4, 4, 2, 3, 2, 0, 3, 2,  6,  4,  5, 6, 3, 3,  0,  5, 7, 9, 1, 7, 2,  5, 3, 3 };

/*****************************************************************************/

Hero::Hero (const unsigned char hero_class, const unsigned char hero_name)
{
	int 	temp;

	classification = hero_class;
	name = hero_name;
	magic_schools = 0;
	has_wisdom = false;
	level = 1;
	initial_skills = 2;

	switch (classification) {
		/************\
		* ALCHEMISTS *
		\************/
		case ALCHEMIST:
			skill_chances = (unsigned char *) Alchemist_secSkill;
			switch (name) {
				case FAFNER:
					skills [0] = SCHOLAR;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case IONA:
					skills [0] = SCHOLAR;
					skills [1] = INTELLIGENCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case NEELA:
					skills [0] = SCHOLAR;
					skills [1] = ARMORER;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case PIQUEDRAM:
					skills [0] = MYSTICISM;
					skills [1] = SCOUTING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case JOSEPHINE:
					skills [0] = MYSTICISM;
					skills [1] = SORCERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case RISSA:
					skills [0] = MYSTICISM;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case THANE:
					skills [0] = SCHOLAR;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case TOROSAR:
					skills [0] = MYSTICISM;
					skills [1] = TACTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				default:
					break;
			}
			break;


		/************\
		* BARBARIANS *
		\************/
		case BARBARIAN:
			skill_chances = (unsigned char *) Barbarian_secSkill;
			switch (name) {
				case CRAG_HACK:
					skills [0] = OFFENSE;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case GRETCHIN:
					skills [0] = OFFENSE;
					skills [1] = PATHFINDING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case GURNISSON:
					skills [0] = OFFENSE;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case JABARKAS:
					skills [0] = OFFENSE;
					skills [1] = ARCHERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case KRELLION:
					skills [0] = OFFENSE;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case SHIVA:
					skills [0] = OFFENSE;
					skills [1] = SCOUTING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case TYRAXOR:
					skills [0] = OFFENSE;
					skills [1] = TACTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case YOG:
					skills [0] = OFFENSE;
					skills [1] = BALLISTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				default:
					break;
			}
			break;


		/**************\
		* BEASTMASTERS *
		\**************/
		case BEASTMASTER:
			skill_chances = (unsigned char *) Beastmaster_secSkill;
			switch (name) {
				case ALKIN:
					skills [0] = ARMORER;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case BROGHILD:
					skills [0] = ARMORER;
					skills [1] = SCOUTING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case BRON:
					skills [0] = ARMORER;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case DRAKON:
					skills [0] = ARMORER;
					skills [1] = LEADERSHIP;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case GERWULF:
					skills [0] = ARMORER;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case KORBAC:
					skills [0] = ARMORER;
					skills [1] = PATHFINDING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case TAZAR:
					skills [0] = ARMORER;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case WYSTAN:
					skills [0] = ARMORER;
					skills [1] = ARCHERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				default:
					break;
			}
			break;


		/***************\
		* DEATH KNIGHTS *
		\***************/
		case DEATH_KNIGHT:
			skill_chances = (unsigned char *) Death_secSkill;
			switch (name) {
				case CHARNA:
					skills [0] = NECROMANCY;
					skills [1] = TACTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case CLAVIUS:
					skills [0] = NECROMANCY;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case GALTHRAN:
					skills [0] = NECROMANCY;
					skills [1] = ARMORER;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case ISRA:
					skills [0] = NECROMANCY;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case MOANDOR:
					skills [0] = NECROMANCY;
					skills [1] = LEARNING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case TAMIKA:
					skills [0] = NECROMANCY;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case STRAKER:
					skills [0] = NECROMANCY;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case VOKIAL:
					skills [0] = NECROMANCY;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				default:
					break;
			}
			break;


		/***********\
		* DEMONIACS *
		\***********/
		case DEMONIAC:
			skill_chances = (unsigned char *) Demoniac_secSkill;
			switch (name) {
				case RASHKA:
					skills [0] = SCHOLAR;
					skills [1] = WISDOM;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					has_wisdom = true;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case CALH:
					skills [0] = ARCHERY;
					skills [1] = SCOUTING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case FIONA:
					skills [0] = SCOUTING;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case IGNATIUS:
					skills [0] = TACTICS;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case MARIUS:
					skills [0] = ARMORER;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case NYMUS:
					skills [0] = OFFENSE;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case PYRE:
					skills [0] = LOGISTICS;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case OCTAVIA:
					skills [0] = SCHOLAR;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				default:
					break;
			}
			break;


		/*********\
		* KNIGHTS *
		\*********/
		case KNIGHT:
			skill_chances = (unsigned char *) Knight_secSkill;
			switch (name) {
				case EDRIC:
					skills [0] = LEADERSHIP;
					skills [1] = ARMORER;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case ORRIN:
					skills [0] = LEADERSHIP;
					skills [1] = ARCHERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case SYLVIA:
					skills [0] = LEADERSHIP;
					skills [1] = NAVIGATION;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case LORD_HAART:
					skills [0] = LEADERSHIP;
					skills [1] = ESTATES;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case VALESKA:
					skills [0] = LEADERSHIP;
					skills [1] = ARCHERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case CHRISTIAN:
					skills [0] = LEADERSHIP;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case SORSHA:
					skills [0] = LEADERSHIP;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case TYRIS:
					skills [0] = LEADERSHIP;
					skills [1] = TACTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case SIR_MULLICH:
					skills [0] = LEADERSHIP;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				default:
					break;
			}
			break;


		/***********\
		* OVERLORDS *
		\***********/
		case OVERLORD:
			skill_chances = (unsigned char *) Overlord_secSkill;
			switch (name) {
				case AJIT:
					skills [0] = LEADERSHIP;
					skills [1] = RESISTANCE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case ARLACH:
					skills [0] = OFFENSE;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case DACE:
					skills [0] = TACTICS;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case DAMACON:
					skills [0] = OFFENSE;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case GUNNAR:
					skills [0] = TACTICS;
					skills [1] = LOGISTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case LORELEI:
					skills [0] = LEADERSHIP;
					skills [1] = SCOUTING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case SHAKTI:
					skills [0] = OFFENSE;
					skills [1] = TACTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case SYNCA:
					skills [0] = LEADERSHIP;
					skills [1] = SCHOLAR;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				default:
					break;
			}
			break;


		/***************\
		* PLANESWALKERS *
		\***************/
		case PLANESWALKER:
			skill_chances = (unsigned char *) Planeswalker_secSkill;
			switch (name) {
				case ERDAMON:
					skills [0] = TACTICS;
					skills [1] = ESTATES;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case FIUR:
					skills [0] = OFFENSE;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case IGNISSA:
					skills [0] = OFFENSE;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case KALT:
					skills [0] = TACTICS;
					skills [1] = LEARNING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case LACUS:
					skills [0] = TACTICS;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case MONERE:
					skills [0] = OFFENSE;
					skills [1] = LOGISTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case PASIS:
					skills [0] = OFFENSE;
					skills [1] = ARTILLERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case THUNAR:
					skills [0] = TACTICS;
					skills [1] = ESTATES;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				default:
					break;
			}
			break;


		/*********\
		* RANGERS *
		\*********/
		case RANGER:
			skill_chances = (unsigned char *) Ranger_secSkill;
			switch (name) {
				case CLANCY:
					skills [0] = RESISTANCE;
					skills [1] = PATHFINDING;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case IVOR:
					skills [0] = ARCHERY;
					skills [1] = OFFENSE;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case JENOVA:
					skills [0] = ARCHERY;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case KYRRE:
					skills [0] = ARCHERY;
					skills [1] = LOGISTICS;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case MEPHALA:
					skills [0] = LEADERSHIP;
					skills [1] = ARMORER;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case RYLAND:
					skills [0] = LEADERSHIP;
					skills [1] = DIPLOMACY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case THORGRIM:
					skills [0] = RESISTANCE;
					expertize [0] = ADVANCED;
					initial_skills = 1;
					for (temp = 1; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case UFRETIN:
					skills [0] = RESISTANCE;
					skills [1] = LUCK;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				case GELU:
					skills [0] = LEADERSHIP;
					skills [1] = ARCHERY;
					expertize [0] = BASIC;
					expertize [1] = BASIC;
					for (temp = 2; temp < 8; temp++) {
						skills [temp] = (unsigned char) NULL_SKILL;
						expertize [temp] = (unsigned char) 0;
					}
					break;

				default:
					break;
			}
			break;

		default:
			break;
	}
}

/*****************************************************************************/

Hero::~Hero () {}

/*****************************************************************************/

unsigned char 	Hero::get_magic_schools () const 	{ return 	magic_schools; }

/*****************************************************************************/

bool 				Hero::get_has_wisdom () const 	{ return 	has_wisdom; }

/*****************************************************************************/

unsigned char 	Hero::get_hero_level () const 	{ return 	level; }

/*****************************************************************************/

bool 				Hero::is_magic_school (const unsigned char skill) const
{
	return 	((skill == AIR_MAGIC) || (skill == EARTH_MAGIC) || (skill == FIRE_MAGIC) || (skill == WATER_MAGIC)) ? true : false;
}

/*****************************************************************************/

void 			Hero::print_Name () const
{
	int 	i;

	switch(classification) {
		case ALCHEMIST:
			std::cout << Alchemists_Names [name] << std::endl;
			for (i = 0; i < strlen (Alchemists_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case BARBARIAN:
			std::cout << Barbarians_Names [name] << std::endl;
			for (i = 0; i < strlen (Barbarians_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case BEASTMASTER:
			std::cout << Beastmasters_Names [name] << std::endl;
			for (i = 0; i < strlen (Beastmasters_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case DEATH_KNIGHT:
			std::cout << Death_Knights_Names [name] << std::endl;
			for (i = 0; i < strlen (Death_Knights_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case DEMONIAC:
			std::cout << Demoniacs_Names [name] << std::endl;
			for (i = 0; i < strlen (Demoniacs_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case KNIGHT:
			std::cout << Knights_Names [name] << std::endl;
			for (i = 0; i < strlen (Knights_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case OVERLORD:
			std::cout << Overlords_Names [name] << std::endl;
			for (i = 0; i < strlen (Overlords_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case PLANESWALKER:
			std::cout << Planeswalkers_Names [name] << std::endl;
			for (i = 0; i < strlen (Planeswalkers_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		case RANGER:
			std::cout << Rangers_Names [name] << std::endl;
			for (i = 0; i < strlen (Rangers_Names [name]); i++)
				std::cout << "~";
			std::cout << std::endl;
			break;

		default:
			std::cout << "Are you nuts? You should not be here!" << std::endl;
			break;
	}
}

/*****************************************************************************/

double * 				Hero::ANSA_policy ()
{
	unsigned char 		i;
	unsigned char 		slot;
	bool * 				available_skills;
	unsigned char * 	skills_so_far = new unsigned char [SKILL_SLOTS];
	unsigned char 		total_remaining_weight;
	double 				prob_so_far;
	double * 			probabilities = new double [DIFF_SEC_SKILLS];

	// Initialize probability variables to ZERO.
	for (i = 0; i < DIFF_SEC_SKILLS; i++)
		probabilities [i] = (double) 0.0;
	prob_so_far = (double) 1.0;
	
	// Initialize available skills array.
	available_skills = new bool [DIFF_SEC_SKILLS];
	for (i = 0; i < DIFF_SEC_SKILLS; i++) {
		if ( (skill_chances [i] == 0) )
			available_skills [i] = false;
		else
			available_skills [i] = true;
	}
	available_skills [ skills [0] ] = false;
	available_skills [ skills [1] ] = false;

	// Create a duplicate of hero's original skills and count initial remaining total weight.
	total_remaining_weight = TOTAL_CHANCES;
	for (slot = 0; slot < SKILL_SLOTS; slot++) {
		skills_so_far [slot] = skills [slot];
		total_remaining_weight -= skill_chances [ skills [slot] ];
	}

	/*
	** Implement Depth-First search.
	*/
	depth_first_search (initial_skills, available_skills, skills_so_far, get_magic_schools (), get_has_wisdom (), prob_so_far, total_remaining_weight, probabilities);

	delete [] skills_so_far;
	delete [] available_skills;

	return 	probabilities;
}

/*****************************************************************************/

void 				Hero::depth_first_search (const unsigned char slot, bool * available_skills, unsigned char * skills_so_far, const unsigned char magic_schools, bool wisdom, const double prob_so_far, const unsigned char remaining_weight, double * probabilities)
{
	register unsigned long int temp;
	register unsigned char 		pointer;
	double 							new_prob_so_far, current_prob;

	if (slot < SKILL_SLOTS - 1) {
		bool * 						next_slot_available_skills = new bool [DIFF_SEC_SKILLS];
		register unsigned char 	i;

		// Initialize next slot's available skills to a duplicate of currently available choices.
		for (i = 0; i < DIFF_SEC_SKILLS; i++)
			next_slot_available_skills [i] = available_skills [i];

		if ( (initial_skills == 2) && (slot == DEFAULT_WISDOM_LEVEL) && (!wisdom) ) {
			// ONLY available choice is WISDOM, therefore probability is 1 for this skill.
			skills_so_far [slot] = WISDOM;
			next_slot_available_skills [WISDOM] = false;
			// Since prob(WISDOM) = 1, then all I have to do is pass the same argument on prob_so_far.
			depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, magic_schools, true, prob_so_far, remaining_weight - skill_chances [WISDOM], probabilities);
			skills_so_far [slot] = (unsigned char) NULL_SKILL;
		}
		else if ( (initial_skills == 1) && (slot == DEFAULT_WISDOM_LEVEL - 1) && (!wisdom) ) {
			// ONLY available choice is WISDOM, therefore probability is 1 for this skill.
			skills_so_far [slot] = WISDOM;
			next_slot_available_skills [WISDOM] = false;
			// Since prob(WISDOM) = 1, then all I have to do is pass the same argument on prob_so_far.
			depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, magic_schools, true, prob_so_far, remaining_weight - skill_chances [WISDOM], probabilities);
			skills_so_far [slot] = (unsigned char) NULL_SKILL;
		}
		else if ( (initial_skills == 2) && (slot == DEFAULT_MAGIC_SCHOOL_LEVEL) && (magic_schools == 0) ) {
			/*
			** Hero must acquire a MAGIC SCHOOL, so let him follow (ONLY) each one of the "magical" paths. :P
			*/
			temp = (unsigned long int) skill_chances [AIR_MAGIC] + skill_chances [EARTH_MAGIC] + skill_chances [FIRE_MAGIC] + skill_chances [WATER_MAGIC];
				
			for (pointer = 0; pointer < 4; pointer++) {
				skills_so_far [slot] = Magic_Schools [pointer];
				next_slot_available_skills [ Magic_Schools [pointer] ] = false;
				// Chance is equal to: weight(current_magic_school) / SUM ( weight(Magic_Schools) ).
				current_prob = (double) ((double) skill_chances [ Magic_Schools [pointer] ]) / ((double) temp);
				new_prob_so_far = prob_so_far * current_prob;
				depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, 1, wisdom, new_prob_so_far, remaining_weight - skill_chances [ Magic_Schools [pointer] ], probabilities);
				skills_so_far [slot] = (unsigned char) NULL_SKILL;
				next_slot_available_skills [ Magic_Schools [pointer] ] = true;
			}
		}
		else if ( (initial_skills == 1) && (slot == DEFAULT_MAGIC_SCHOOL_LEVEL - 1) && (magic_schools == 0) ) {
			/*
			** Hero must acquire a MAGIC SCHOOL, so let him follow (ONLY) each one of the "magical" paths. :P
			*/
			temp = (unsigned long int) skill_chances [AIR_MAGIC] + skill_chances [EARTH_MAGIC] + skill_chances [FIRE_MAGIC] + skill_chances [WATER_MAGIC];
				
			for (pointer = 0; pointer < 4; pointer++) {
				skills_so_far [slot] = Magic_Schools [pointer];
				next_slot_available_skills [ Magic_Schools [pointer] ] = false;
				// Chance is equal to: weight(current_magic_school) / SUM ( weight(Magic_Schools) ).
				current_prob = (double) ((double) skill_chances [ Magic_Schools [pointer] ]) / ((double) temp);
				new_prob_so_far = prob_so_far * current_prob;
				depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, 1, wisdom, new_prob_so_far, remaining_weight - skill_chances [ Magic_Schools [pointer] ], probabilities);
				skills_so_far [slot] = (unsigned char) NULL_SKILL;
				next_slot_available_skills [ Magic_Schools [pointer] ] = true;
			}
		}
		else {
			// Hero can acquire ANY of the available skills.
			for (pointer = 1; pointer < DIFF_SEC_SKILLS; pointer++) {
				if (slot == initial_skills)
					std::cerr << "Part of computation: " << (int) pointer << "/" << (int) DIFF_SEC_SKILLS - 1 << "." << std::endl;

				if (available_skills [pointer]) {
					// use skill for this slot.
					skills_so_far [slot] = pointer;
					next_slot_available_skills [pointer] = false;
					current_prob = (double) ((double) skill_chances [ pointer ]) / ((double) remaining_weight);
					new_prob_so_far = prob_so_far * current_prob;
					if (pointer == WISDOM)
						depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, magic_schools, true, new_prob_so_far, remaining_weight - skill_chances [ pointer ], probabilities); 	// Hero gains WISDOM.
					else if ((pointer == AIR_MAGIC) || (pointer == EARTH_MAGIC) || (pointer == FIRE_MAGIC) || (pointer == WATER_MAGIC))
						depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, magic_schools + 1, wisdom, new_prob_so_far, remaining_weight - skill_chances [ pointer ], probabilities); 	// Hero gains one more MAGIC SCHOOL.
					else
						depth_first_search ((unsigned char) slot + 1, next_slot_available_skills, skills_so_far, magic_schools, wisdom, new_prob_so_far, remaining_weight - skill_chances [ pointer ], probabilities); 	// Hero gains neither WISDOM nor any MAGIC SCHOOL.
					skills_so_far [slot] = (unsigned char) NULL_SKILL;
					next_slot_available_skills [pointer] = true;
				}
			}
		}

		delete [] next_slot_available_skills; 	// Free-up memory.
	}
	else {
		/*
		** Final step of recursion.
		*/
		register unsigned char temp_slot;

		for (pointer = 1; pointer < DIFF_SEC_SKILLS; pointer++) {
			if (available_skills [pointer]) {
				// use skill ...
				skills_so_far [slot] = pointer;
				current_prob = (double) ((double) skill_chances [ pointer ]) / ((double) remaining_weight);
				new_prob_so_far = prob_so_far * current_prob;
				for (temp_slot = 0; temp_slot < SKILL_SLOTS; temp_slot++)
					probabilities [ skills_so_far [temp_slot] ] += new_prob_so_far;
				skills_so_far [slot] = NULL_SKILL;
			}
		}
	}

	return;
}

/*****************************************************************************/

char * 	get_skill_name_12 (const unsigned char pointer)
{
	char * Skill_Names [DIFF_SEC_SKILLS] = { "NULL SKILL  ", "AIR MAGIC   ", "ARCHERY     ", "ARMORER     ", "ARTILLERY   ", "BALLISTICS  ", "DIPLOMACY   ", "EAGLE EYE   ", "EARTH MAGIC ", "ESTATES     ", "FIRE MAGIC  ", "FIRST AID   ", "INTELLIGENCE", "LEADERSHIP  ", "LEARNING    ", "LOGISTICS   ", "LUCK        ", "MYSTICISM   ", "NAVIGATION  ", "NECROMANCY  ", "OFFENSE     ", "PATHFINDING ", "RESISTANCE  ", "SCHOLAR     ", "SCOUTING    ", "SORCERY     ", "TACTICS     ", "WATER MAGIC ", "WISDOM      " };

	if (pointer >= DIFF_SEC_SKILLS)
		return 	Skill_Names [0];
	else
		return 	Skill_Names [pointer];
}

/*****************************************************************************/
